#include <bits/stdc++.h>
using namespace std;
ifstream f1("BAI1_16.INP");
ofstream f2("BAI1_16.OUT");
int SoNguyenTo(int n)
{
     if (n<2)
         return 0;
     for (int i=2; i<n; i++)
         if(n%i==0)
             return 0;
     return 1;
}
int main()
{
    int dem=0,max,i,n;
    f1>>n;
    for(i=1;i<=n;i++)
    {
        if(SoNguyenTo(i)==1)
        {
            dem++;
            max=i;
            break;
        }
    }
    //if(dem==0) return 0;
    for(i=i+1;i<n;i++)
    {
        if(n%i==0 && SoNguyenTo(i)==1 && max<i)
        {
            max=i;
        }
    }
    f2<<max;
    f1.close();
    f2.close();
    return 0;
}
